
function vid_mate_get_video_id() {
	var vid_mate_url = window.location.pathname;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	var tmp_re = new RegExp('/news/([^/]+)/([0-9]+)-([^/]+)');
	if (tmp_re.test(vid_mate_url)) {
		var tmp_obj = document.getElementsByTagName('video');
		if (tmp_obj != null && tmp_obj.length > 0) {
			var tmp_m = vid_mate_url.match(tmp_re);
			return tmp_m[2];
		} else {
			return null;
		}
	}
	var tmp_re = new RegExp('/videos/([0-9]+)/([^/]+)');
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		return tmp_m[1];
	}
	return null;
}

function vid_mate_check() {
	if (vid_mate_get_video_id() == null) {
	    vid_mate_set_canDownload(false);
	    return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_video_analytics(vm_content) {
	vid_mate_setParseMsg(60, 90, 'Analytics Video Info');
	var vid_mate_id = vm_content;

	var vid_mate_url = window.location.pathname;

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "ibnlive";
	var tmp_video_file = new vid_mate_video_file();
	tmp_video_file.width = 0;
	tmp_video_file.height = 0;
	tmp_video_file.f_id = vid_mate_id + '_0_0';
	tmp_video_file.length = 0;
	tmp_video_file.quality = '';

	rtn_video.id = vid_mate_id;
	var tmp_metas = document.getElementsByTagName('meta');
	for (var i = 0;i < tmp_metas.length;i ++) {
		var tmp_itemprop = tmp_metas[i].getAttribute('itemprop');
		var tmp_content = tmp_metas[i].getAttribute('content');
		var tmp_property = tmp_metas[i].getAttribute('property');
		if (tmp_itemprop == 'headline') {
			rtn_video.title = tmp_content;
		} else if(tmp_property == 'og:image') {
			rtn_video.picture_default = tmp_content;
			rtn_video.picture_big = tmp_content;
		}
	}
	rtn_video.duration = 0;
	rtn_video.url = document.url;

	if (vid_mate_url.substring(0,6) == '/news/') {
		var tmp_video_obj = document.getElementById('video1');
		if (tmp_video_obj == null) {
			vid_mate_error_default('ibnlive 1');
			return null;
		}
		var tmp_sources = tmp_video_obj.getElementsByTagName('source');
		if (tmp_sources == null || tmp_sources.length <= 0) {
			vid_mate_error_default('ibnlive 2');
			return null;
		}
		var tmp_source = tmp_sources[0];
		var tmp_url = tmp_source.getAttribute('src');
		tmp_video_file.url = decodeURIComponent(tmp_url);
		var tmp_format = vid_mate_get_video_format(tmp_url);
		tmp_video_file.format = tmp_format;
		tmp_video_file.title = tmp_format;
	} else if(vid_mate_url.substring(0,8) == '/videos/') {
		for (var i = 0;i < tmp_metas.length;i ++) {
			var tmp_name = tmp_metas[i].getAttribute('name');
			var tmp_content = tmp_metas[i].getAttribute('content');
			if (tmp_name == 'twitter:player:stream') {
				var tmp_url = tmp_content;
				tmp_video_file.url = decodeURIComponent(tmp_url);
				var tmp_format = vid_mate_get_video_format(tmp_url);
				tmp_video_file.format = tmp_format;
				tmp_video_file.title = tmp_format;
			}
		}
	} else {
		vid_mate_error_default('ibnlive 3');
		return null;
	}

	rtn_video.files.push(tmp_video_file);
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info() {
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	if (!vid_mate_check()) {
		return null;
	}

	var vid_mate_video_id = vid_mate_get_video_id();

	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	vid_mate_video_analytics(vid_mate_video_id);
}

