
function vid_mate_get_video_id() {
	var vid_mate_url = document.location.pathname;
	if (vid_mate_url == null || vid_mate_url.length <= 0) {
		return null;
	}
	var tmp_re = new RegExp("/([^/]+)-([0-9]+)");
	if (tmp_re.test(vid_mate_url)) {
		var tmp_m = vid_mate_url.match(tmp_re);
		if(tmp_m[2].length < 3)
		{
			return null;
		}
		else
		{
			return tmp_m[2];
		}
	}
	return null;
}

function vid_mate_check() {
    if (vid_mate_get_video_id() == null) {
        vid_mate_set_canDownload(false);
		return false;
	} else {
	    vid_mate_set_canDownload(true);
		return true;
	}
}

function vid_mate_video_analytics(vm_content) {
    vid_mate_setParseMsg(60, 90, 'Analytics Video Info');

	var rtn_video = new vid_mate_video();
	rtn_video.check_type = "badjojo";
	var tmp_video_file = new vid_mate_video_file();

	var tmp_content = "";
	if(vm_content.length > 128)
	{
		rtn_video.id = vid_mate_get_video_id();
		tmp_content = vm_content;
	}
	else
	{
		rtn_video.id = vm_content;
		tmp_content = document.body.innerHTML;
	}

	var tmp_re = new RegExp('<h2>([^<]+)</h2>');

	if (!tmp_re.test(tmp_content)) {
		vid_mate_error_default('badjojo 1');
		return null;
	}
	var tmp_m = tmp_content.match(tmp_re);
	rtn_video.title = tmp_m[1];
	var tmp_re = new RegExp('Length: <strong>(([0-9]+):)?([0-9]+):([0-9]+)</strong>');
	if (tmp_re.test(tmp_content)) {
		var tmp_m = tmp_content.match(tmp_re);
		var tmp_hour = tmp_m[2];
		var tmp_min = tmp_m[3];
		var tmp_second = tmp_m[4];
		rtn_video.duration = Number(tmp_hour) * 3600 + Number(tmp_min) * 60 + Number(tmp_second);
	}
	rtn_video.url = document.URL;

	if(vm_content.length > 128)
	{
		var pos1 = vm_content.indexOf("<video");
		if(-1 == pos1)
		{
			vid_mate_error_default('badjojo 2.1');
			return null;
		}
		var pos2 = vm_content.indexOf(">", pos1);
		if(-1 == pos2)
		{
			vid_mate_error_default('badjojo 2.2');
			return null;
		}
		var video_content = vm_content.substring(pos1, pos2);
		var pos3 = video_content.indexOf("poster=\"");
		if(-1 == pos3)
		{
			vid_mate_error_default('badjojo 2.3');
			return null;
		}
		var pos4 = video_content.indexOf("\"", pos3 + 8);
		if(-1 == pos4)
		{
			vid_mate_error_default('badjojo 2.4');
			return null;
		}

		rtn_video.picture_default = video_content.substring(pos3 + 8, pos4)
		rtn_video.picture_big = rtn_video.picture_default;

		//source
		var pos5 = vm_content.indexOf("<source");
		if(-1 == pos5)
		{
			vid_mate_error_default('badjojo 2.5');
			return null;
		}
		var pos6 = vm_content.indexOf(">", pos5);
		if(-1 == pos6)
		{
			vid_mate_error_default('badjojo 2.6');
			return null;
		}
		var source_content = vm_content.substring(pos5, pos6);
		var pos7 = source_content.indexOf("src=\"");
		if(-1 == pos7)
		{
			vid_mate_error_default('badjojo 2.7');
			return null;
		}
		var pos8 = source_content.indexOf("\"", pos7 + 5);
		if(-1 == pos8)
		{
			vid_mate_error_default('badjojo 2.8');
			return null;
		}
		var video_url = source_content.substring(pos7 + 5, pos8);
		tmp_video_file.url = decodeURIComponent(video_url);

	}
	else
	{
		var tmp_video = document.getElementById('ts_videoplayer');
		if (tmp_video == null) {
			vid_mate_error_default('badjojo 2');
			return null;
		}
		rtn_video.picture_default = tmp_video.getAttribute('poster');
		rtn_video.picture_big = tmp_video.getAttribute('poster');

		var tmp_sources = tmp_video.getElementsByTagName('source');
		if (tmp_sources.length <= 0) {
			vid_mate_error_default('badjojo 3');
			return null;
		}
		tmp_video_file.url = decodeURIComponent(tmp_sources[0].getAttribute('src'));
	}

	var tmp_format = vid_mate_get_video_format(tmp_video_file.url);
	tmp_video_file.format = tmp_format;
	tmp_video_file.title = tmp_format;
	tmp_video_file.f_id = rtn_video.id + '_0_0';
	rtn_video.files.push(tmp_video_file);
	vid_mate_setParseMsg(100, 100, 'Completed');
	vid_mate_set_videoInfo(JSON.stringify(rtn_video));
}

function vid_mate_get_video_info() {
    vid_mate_setParseMsg(10, 20, 'Start Analytics');

	if (!vid_mate_check()) {
		return null;
	}

	var vid_mate_video_id = vid_mate_get_video_id();
	vid_mate_setParseMsg(20, 60, 'Get Video Info');

	var tmp_content = document.body.innerHTML;
	if(-1 == tmp_content.indexOf("ts_videoplayer"))
	{
		var url = document.URL;
		if(-1 == url.indexOf("skip_ad"))
		{
			url = url + "?skip_ad";
		}
		var referer = url;
		var cookie = "";
		var userAgent = "Mozilla/5.0 (Linux; Android 4.4; MI 2 Build/KRT16M) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/30.0.0.0 Mobile Safari/537.36";
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	}
	else
	{
		vid_mate_video_analytics(vid_mate_video_id);
	}
}

