var global_document_url = global_document_url || null;
var global_type = global_type || null;
var global_page = global_page || null;
var global_keyword = global_keyword || null;

function vid_mate_check()
{
	vid_mate_set_canDownload(true);
	return true;
}

function cutstr(content, prefix, suffix)
{
	var prefix_len = prefix.length;
	var p1 = content.indexOf(prefix);
	if(-1 == p1)
	{
		return "";
	}
	p1 += prefix_len;
	var p2 = content.indexOf(suffix, p1);
	if(-1 == p2)
	{
		return "";
	}
	return content.substring(p1, p2);
}

function vid_mate_youtubesearch(keyword, type, page)
{
	if(0 == keyword.length)
	{
		return;
	}
	global_keyword = keyword;

	if("video" != type && "playlist" != type && "channel" != type)
	{
		vid_mate_error_default('youtubesearch bad type '+type+'');
		return null;
	}
	global_type = type;

	page = parseInt(page);
	if(page < 1)
	{
		page = 1;
	}
	global_page = page;

	var url = "https://www.youtube.com/results?search_query="+encodeURIComponent(keyword)+"&lclk="+type+"&filters="+type+"&page="+page+"";
	var global_document_url = url;
	
	try {
		var referer = "https://www.youtube.com/";
		var cookie = "";
		if(window.vbrowser.httpGetCookie)
		{
			cookie = window.vbrowser.httpGetCookie(global_document_url);
		}
		else
		{
			cookie = document.cookie;
		}

		var userAgent = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/"+rand_num(530,537)+"."+rand_num(30,37)+" (KHTML, like Gecko) Chrome/"+rand_num(30,39)+".0."+rand_num(1800,2100)+"."+rand_num(50,65)+" Safari/"+rand_num(530,537)+"."+rand_num(30,37)+"";
		//var userAgent = navigator.userAgent;
		var method = "get";
		var data = "";
		vid_mate_app_xhr_adv(url, referer, cookie, userAgent, method, data);
	} catch (e) {
		vid_mate_error_default('youtubesearch http get fail');
		return null;
	}
}

function vid_mate_video_analytics(vm_content)
{
	if("video" == global_type)
	{
		analytics_video(vm_content);
	}
	else if("channel" == global_type)
	{
		analytics_channel(vm_content);
	}
	else if("playlist" == global_type)
	{
		analytics_playlist(vm_content);
	}
	else
	{
		return null;
	}
}

function get_total(vm_content)
{
	var data = cutstr(vm_content, "num-results", "</p>");
	data = data.replace(/\n/g, "");
	data = data.replace(/\r/g, "");

	var tmp_re = new RegExp(/<strong>(.+?)<\/strong>/gm);
	if (!tmp_re.test(data)) 
	{
		return 0;
	}
	var tmp_m = data.match(tmp_re);
	if(0 == tmp_m.length)
	{
		return 0;
	}
	var total = tmp_m.pop();
	total = total.replace("<strong>", "");
	total = total.replace("</strong>", "");
	total = total.replace(/,/g, "");
	total = total.trim();
	return total;
}

function analytics_video(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('youtubesearch video vm_content is empty');
		return null;	
	}

	var data = cutstr(vm_content, "<ol class=\"item-section\">", "role=\"navigation\"");
	if(0 == data.length)
	{
		vid_mate_error_default('youtubesearch video data is empty');
		return null;
	}

	data = data.replace(/\n/g, "");
	data = data.replace(/\r/g, "");

	var tmp_re = new RegExp(/<li><div(.+?)<\/div><\/li>/gm);
	if (!tmp_re.test(data)) 
	{
		vid_mate_error_default('youtubesearch video 1');
		return null;
	}

	var output_result = new vid_mate_search_result();
	output_result.total = get_total(vm_content);
	output_result.type = global_type;
	output_result.page = global_page;
	output_result.keyword = global_keyword;

	var output = new vid_mate_search_output();
	output.status = 1;
	output.data = output_result;

	var tmp_m = data.match(tmp_re);
	for(var i=0; i<tmp_m.length; ++i)
	{
		var row = new vid_mate_search_video_row();
		var item = tmp_m[i];

		var id = cutstr(item, "v=", "\"");
		
		if(0 == id.length)
		{
			vid_mate_error_default('youtubesearch video 2');
			return null;
		}
		id = "#" + id + "&";
		id = cutstr(id, "#", "&");

		var url = "https://m.youtube.com/watch?v="+id+"";
		var image = "https://i.ytimg.com/vi/"+id+"/mqdefault.jpg";
		var title = cutstr(item, "\"ltr\">", "</a>");
		var tmp = cutstr(item, "<ul class=\"yt-lockup-meta-info\">", "</ul>");
		var publishedAt = "";
		var viewCount = 0;
		if(tmp)
		{
			var tmp_re1 = new RegExp(/<li>(.+?)<\/li>/gm);
			if (tmp_re1.test(tmp)) 
			{
				var tmp_m1 = tmp.match(tmp_re1);
				if(2 == tmp_m1.length)
				{
					var publishedAt = tmp_m1[0];
					publishedAt = publishedAt.replace("<li>", "");
					publishedAt = publishedAt.replace("</li>", "");
					publishedAt = publishedAt.trim();

					var viewCount = tmp_m1[1];
					viewCount = viewCount.replace("<li>", "");
					viewCount = viewCount.replace("</li>", "");
					viewCount = viewCount.replace("views", "");
					viewCount = viewCount.replace(/,/g, "");
					viewCount = viewCount.trim();
				}
			}
		}

		var duration = "00:00:00";
		tmp = cutstr(item, "\"video-time\"", "</span>");
		if(tmp)
		{
			tmp = tmp+"<";
			tmp = cutstr(tmp, ">", "<");
			if(tmp)
			{
				var len = tmp.length;
				//var p = "00:00:00".substring(0, len);
				var p = "00:00:00".substring(0, 7 - len + 1);
				duration = p + tmp;
			}
		}

		row.id = id;
		row.title = title;
		row.url = url;
		row.image = image;
		row.viewCount = viewCount;
		row.duration = duration;
		row.publishedAt = publishedAt;
		output_result.rows.push(row);
	}
	
	if(0 == output_result.rows.length)
	{
		vid_mate_error_default('youtubesearch video 3');
		return null;	
	}

	var output = new vid_mate_search_output();
	output.status = 1;
	output.data = output_result;
	window.vbrowser.setSearchInfo(JSON.stringify(output));
	return true;
}

function analytics_channel(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('youtubesearch channel vm_content is empty');
		return null;	
	}

	var data = cutstr(vm_content, "<ol class=\"item-section\">", "role=\"navigation\"");
	if(0 == data.length)
	{
		vid_mate_error_default('youtubesearch channel data is empty');
		return null;
	}

	data = data.replace(/\n/g, "");
	data = data.replace(/\r/g, "");

	var tmp_re = new RegExp(/<li><div(.+?)<\/div><\/li>/gm);
	if (!tmp_re.test(data)) 
	{
		vid_mate_error_default('youtubesearch channel 1');
		return null;
	}

	var output_result = new vid_mate_search_result();
	output_result.total = get_total(vm_content);
	output_result.type = global_type;
	output_result.page = global_page;
	output_result.keyword = global_keyword;

	var tmp_m = data.match(tmp_re);
	for(var i=0; i<tmp_m.length; ++i)
	{
		var row = new vid_mate_search_channel_row();
		var item = tmp_m[i];

		var id = cutstr(item, "data-ytid=\"", "\"");
		
		if(0 == id.length)
		{
			vid_mate_error_default('youtubesearch channel 2');
			return null;
		}

		var image = cutstr(item, "video-thumb", "width=");
		if(image)
		{
			image = cutstr(image, "src=\"", "\"");
		}

		var title = cutstr(item, "\"ltr\">", "</a>");
		var publishedAt = "";
		var subscriberCount = 0;
		var videoCount = 0;

		var tmp = cutstr(item, "subscriber-count", "<");
		if(tmp)
		{
			tmp = tmp +"<";
			tmp = cutstr(tmp, ">", "<");
			subscriberCount = parseInt(tmp);
		}

		tmp = cutstr(item, "<ul class=\"yt-lockup-meta-info\">", "</ul>");
		if(tmp)
		{
			var tmp_re1 = new RegExp(/<li>(.+?)<\/li>/gm);
			if (tmp_re1.test(tmp)) 
			{
				var tmp_m1 = tmp.match(tmp_re1);
				if(tmp_m1.length > 0)
				{
					tmp = tmp_m1.pop();	
					tmp = tmp.replace("<li>", "");
					tmp = tmp.replace("</li>", "");
					tmp = tmp.replace("videos", "");
					tmp = tmp.trim();
					videoCount = parseInt(tmp);
				}
			}
		}

		row.id = id;
		row.title = title;
		row.image = image;
		row.publishedAt = publishedAt;
		row.subscriberCount = subscriberCount;
		row.videoCount = videoCount;
		output_result.rows.push(row);
	}

	if(0 == output_result.rows.length)
	{
		vid_mate_error_default('youtubesearch channel 3');
		return null;	
	}

	var output = new vid_mate_search_output();
	output.status = 1;
	output.data = output_result;
	window.vbrowser.setSearchInfo(JSON.stringify(output));
	return true;
}

function analytics_playlist(vm_content)
{
	if(!vm_content)
	{
		vid_mate_error_default('youtubesearch playlist vm_content is empty');
		return null;	
	}

	var data = cutstr(vm_content, "<ol class=\"item-section\">", "role=\"navigation\"");
	if(0 == data.length)
	{
		vid_mate_error_default('youtubesearch playlist data is empty');
		return null;
	}


	data = data.replace(/\n/g, "");
	data = data.replace(/\r/g, "");

	var tmp_re = new RegExp(/<li><div(.+?)<\/div><\/li>/gm);
	if (!tmp_re.test(data)) 
	{
		vid_mate_error_default('youtubesearch playlist 1');
		return null;
	}

	var output_result = new vid_mate_search_result();
	output_result.total = get_total(vm_content);
	output_result.type = global_type;
	output_result.page = global_page;
	output_result.keyword = global_keyword;

	var output = new vid_mate_search_output();
	output.status = 1;
	output.data = output_result;

	var tmp_m = data.match(tmp_re);
	for(var i=0; i<tmp_m.length; ++i)
	{
		var row = new vid_mate_search_playlist_row();
		var item = tmp_m[i];

		var id = cutstr(item, "data-list-id=\"", "\"");
		if(0 == id.length)
		{
			vid_mate_error_default('youtubesearch playlist 2');
			return null;
		}

		var vid = cutstr(item, "data-video-ids=\"", "\"");
		if(0 == vid.length)
		{
			vid_mate_error_default('youtubesearch playlist 3');
			return null;
		}

		var image = "https://i.ytimg.com/vi/"+vid+"/mqdefault.jpg";
		var title = cutstr(item, "\"ltr\">", "</a>");
		var itemCount = 1;
		var tmp = cutstr(item, "video-count-label", "</b>");
		if(tmp)
		{
			tmp = tmp + "<";
			tmp = cutstr(tmp, "<b>", "<");
			if(tmp)
			{
				itemCount = parseInt(tmp);	
			}
		}
		var publishedAt = "";

		row.id = id;
		row.title = title;
		row.image = image;
		row.itemCount = itemCount;
		row.publishedAt = publishedAt;
		output_result.rows.push(row);
	}

	if(0 == output_result.rows.length)
	{
		vid_mate_error_default('youtubesearch playlist 4');
		return null;	
	}

	var output = new vid_mate_search_output();
	output.status = 1;
	output.data = output_result;
	window.vbrowser.setSearchInfo(JSON.stringify(output));
	return true;
}

function vid_mate_search_output() 
{
    this.status = "";
    this.data = "";
}

function vid_mate_search_result() 
{
    this.total = "";
	this.type = "";
	this.page = "",
	this.keyword = "";
    this.rows = [];
}

function vid_mate_search_video_row() 
{
    this.id = "";
    this.url = "";
    this.publishedAt = "";
    this.title = "";
    this.image = "";
    this.viewCount = "";
    this.duration = "";
}

function vid_mate_search_playlist_row() 
{
    this.id = "";
    this.publishedAt = "";
    this.title = "";
    this.image = "";
    this.itemCount = "";
}

function vid_mate_search_channel_row() 
{
    this.id = "";
    this.publishedAt = "";
    this.title = "";
    this.image = "";
    this.videoCount = "";
    this.subscriberCount = "";
}

function vid_mate_get_video_info_on_blank(url)
{
	vid_mate_get_video_info(url);
}

function vid_mate_get_video_info(url)
{
	var keyword = "body";
	var type = "channel";
	var page = 4;
	vid_mate_youtubesearch(keyword, type, page);
}

function rand_num(min, max)
{
	return parseInt(Math.random() * (max - min) + min);
}
